Index: uspace/lib/device/include/hr.h
===================================================================
--- uspace/lib/device/include/hr.h	(revision af4ecb76e05b5a44b9806df2c25c8bb7a5550326)
+++ uspace/lib/device/include/hr.h	(revision 155d34fab0cbaad1a3fb64bb7f99b7e653b5d098)
@@ -130,6 +130,6 @@
 extern errno_t		 hr_add_hotspare(hr_t *, const char *, const char *);
 extern errno_t		 hr_print_status(hr_t *);
-extern const char	*hr_get_vol_status_msg(hr_vol_status_t);
-extern const char	*hr_get_ext_status_msg(hr_ext_status_t);
+extern const char	*hr_get_vol_state_str(hr_vol_status_t);
+extern const char	*hr_get_ext_state_str(hr_ext_status_t);
 extern const char	*hr_get_layout_str(hr_layout_t);
 extern const char	*hr_get_metadata_type_str(hr_metadata_type_t);
Index: uspace/lib/device/src/hr.c
===================================================================
--- uspace/lib/device/src/hr.c	(revision af4ecb76e05b5a44b9806df2c25c8bb7a5550326)
+++ uspace/lib/device/src/hr.c	(revision 155d34fab0cbaad1a3fb64bb7f99b7e653b5d098)
@@ -225,5 +225,5 @@
 	printf("devname: %s\n", devname);
 
-	printf("status: %s\n", hr_get_vol_status_msg(vol_info->status));
+	printf("status: %s\n", hr_get_vol_state_str(vol_info->status));
 
 	printf("level: %d\n", vol_info->level);
@@ -264,9 +264,9 @@
 			    (i == vol_info->extent_no - 1 &&
 			    vol_info->layout == HR_RLQ_RAID4_N))
-				printf("          P   %s    %zu       %s\n", hr_get_ext_status_msg(ext->status), i, devname);
+				printf("          P   %s    %zu       %s\n", hr_get_ext_state_str(ext->status), i, devname);
 			else
-				printf("              %s    %zu       %s\n", hr_get_ext_status_msg(ext->status), i, devname);
+				printf("              %s    %zu       %s\n", hr_get_ext_state_str(ext->status), i, devname);
 		} else {
-			printf("          %s    %zu       %s\n", hr_get_ext_status_msg(ext->status), i, devname);
+			printf("          %s    %zu       %s\n", hr_get_ext_state_str(ext->status), i, devname);
 		}
 	}
@@ -286,5 +286,5 @@
 		}
 		printf("            %s   %zu     %s\n",
-		    hr_get_ext_status_msg(ext->status), i, devname);
+		    hr_get_ext_state_str(ext->status), i, devname);
 	}
 
@@ -477,5 +477,11 @@
 }
 
-const char *hr_get_vol_status_msg(hr_vol_status_t status)
+/** Get volume state string.
+ *
+ * @param state	State value
+ *
+ * @return State string
+ */
+const char *hr_get_vol_state_str(hr_vol_status_t status)
 {
 	switch (status) {
@@ -495,5 +501,11 @@
 }
 
-const char *hr_get_ext_status_msg(hr_ext_status_t status)
+/** Get extent state string.
+ *
+ * @param state	State value
+ *
+ * @return State string
+ */
+const char *hr_get_ext_state_str(hr_ext_status_t status)
 {
 	switch (status) {
@@ -517,4 +529,10 @@
 }
 
+/** Get volume layout string.
+ *
+ * @param layout Layout value
+ *
+ * @return Layout string
+ */
 const char *hr_get_layout_str(hr_layout_t layout)
 {
@@ -537,4 +555,10 @@
 }
 
+/** Get volume metadata type string.
+ *
+ * @param type Metadata type value
+ *
+ * @return Metadata type string
+ */
 const char *hr_get_metadata_type_str(hr_metadata_type_t type)
 {
Index: uspace/srv/bd/hr/raid1.c
===================================================================
--- uspace/srv/bd/hr/raid1.c	(revision af4ecb76e05b5a44b9806df2c25c8bb7a5550326)
+++ uspace/srv/bd/hr/raid1.c	(revision 155d34fab0cbaad1a3fb64bb7f99b7e653b5d098)
@@ -609,5 +609,5 @@
 	if (hs_state != HR_EXT_HOTSPARE) {
 		HR_ERROR("hr_raid1_rebuild(): invalid hotspare state \"%s\", "
-		    "aborting rebuild\n", hr_get_ext_status_msg(hs_state));
+		    "aborting rebuild\n", hr_get_ext_state_str(hs_state));
 		rc = EINVAL;
 		goto error;
Index: uspace/srv/bd/hr/raid5.c
===================================================================
--- uspace/srv/bd/hr/raid5.c	(revision af4ecb76e05b5a44b9806df2c25c8bb7a5550326)
+++ uspace/srv/bd/hr/raid5.c	(revision 155d34fab0cbaad1a3fb64bb7f99b7e653b5d098)
@@ -745,5 +745,5 @@
 	if (hs_state != HR_EXT_HOTSPARE) {
 		HR_ERROR("hr_raid5_rebuild(): invalid hotspare state \"%s\", "
-		    "aborting rebuild\n", hr_get_ext_status_msg(hs_state));
+		    "aborting rebuild\n", hr_get_ext_state_str(hs_state));
 		rc = EINVAL;
 		goto end;
Index: uspace/srv/bd/hr/util.c
===================================================================
--- uspace/srv/bd/hr/util.c	(revision af4ecb76e05b5a44b9806df2c25c8bb7a5550326)
+++ uspace/srv/bd/hr/util.c	(revision 155d34fab0cbaad1a3fb64bb7f99b7e653b5d098)
@@ -385,6 +385,6 @@
 	hr_ext_status_t old = vol->extents[ext_idx].status;
 	HR_NOTE("\"%s\": changing extent %zu state: %s -> %s\n",
-	    vol->devname, ext_idx, hr_get_ext_status_msg(old),
-	    hr_get_ext_status_msg(s));
+	    vol->devname, ext_idx, hr_get_ext_state_str(old),
+	    hr_get_ext_state_str(s));
 	vol->extents[ext_idx].status = s;
 }
@@ -399,6 +399,6 @@
 	hr_ext_status_t old = vol->hotspares[hs_idx].status;
 	HR_NOTE("\"%s\": changing hotspare %zu state: %s -> %s\n",
-	    vol->devname, hs_idx, hr_get_ext_status_msg(old),
-	    hr_get_ext_status_msg(s));
+	    vol->devname, hs_idx, hr_get_ext_state_str(old),
+	    hr_get_ext_state_str(s));
 	vol->hotspares[hs_idx].status = s;
 }
@@ -409,5 +409,5 @@
 
 	HR_NOTE("\"%s\": changing volume state: %s -> %s\n", vol->devname,
-	    hr_get_vol_status_msg(vol->status), hr_get_vol_status_msg(new));
+	    hr_get_vol_state_str(vol->status), hr_get_vol_state_str(new));
 	vol->status = new;
 }